// $Id: common.cpp,v 1.2 2002/04/26 15:18:12 jjlupa Exp $
//
// ypost (Yet Another Poster)
// This code is copyright Jonathan Lupa, 2000. <jjlupa@jamdata.net>  To the
//  extent that it is released, it is released under the GNU General Public License
//  v2 or greater. The author retains all rights with respect to this code.
//
// If you have a desire to use this code outside of the GPL, drop me an email and
//  I would be happy to work with you under an alternate licence.  If you just want
//  to write code, then I would probably be happy to release it to you as under
//  the perl artistic license.
//
// Implements independent.h

namespace std
    {}
using namespace std;

#ifdef WIN32 // God can this get annoying...
#   pragma warning(disable:4786)
#endif

#include "common.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <assert.h>
#include <iostream>

#ifdef WIN32
#   include <winsock2.h>
#else
#   include <stdio.h>
#   include <unistd.h>
#endif

namespace common
{
    unsigned long timeval_diff( const timeval & t1, const timeval & t2 )
    {
        if ( ! ( t1.tv_sec > t2.tv_sec || ( t1.tv_sec == t2.tv_sec && t1.tv_usec >= t2.tv_usec ) ) )
	{
	    cerr << "BAD TIMEVALS: [ " << t1.tv_sec << "-" << t1.tv_usec << " ], ["<< t2.tv_sec << "-" << t2.tv_usec << " ]" << endl;
	    assert( false );
	}

        return ( ( ( t1.tv_sec * 1000000 ) + t1.tv_usec ) - ( ( t2.tv_sec * 1000000 ) + t2.tv_usec ) );
    }
}
