// $Id: encode.cpp,v 1.4 2002/04/22 23:07:41 jjlupa Exp $
//
// ypost (Yet Another Poster)
// This code is copyright John Ridley, 2000. <john.ridley@gt.org>  To the
//  extent that it is released, it is released under the GNU General Public License
//  v2 or greater. The author retains all rights with respect to this code.
//
// If you have a desire to use this code outside of the GPL, drop me an email and
//  I would be happy to work with you under an alternate licence.  If you just want
//  to write code, then I would probably be happy to release it to you as under
//  the perl artistic license.

namespace std
    {}
using namespace std;

#ifdef WIN32 // God can this get annoying...
#   pragma warning(disable:4786)
#endif

#include "uuencode.h"

#include <sys/types.h>
#include <sys/stat.h>

#ifdef WIN32
#else
#   include <stdio.h>
#   include <unistd.h>
#endif


// *********************************************************
// sample usage:
//  uuencode coder("/home/jrr/work/18ktest",400);
//  long NumSegments = coder.NumSegments();
//  long BufSize = coder.BufSpaceNeeded();
//  char *buf = (char *)malloc(BufSize);
//  for (int x=0; x<NumSegments; x++)
//  {
//    if (!coder.EncodeSegment(x+1,buf,BufSize))
//    {
//      printf( "Unable to encode segment %d; quitting\n", x+1);
//      exit(255);
//    }
//    char filename[128];
//    sprintf(filename,"file.uu.%3.3d",x+1);
//    FILE *file = fopen(filename,"wb");
//    fputs(buf, file);
//    fclose(file);
//  }
// ********************************************************

generic_encoder::generic_encoder(const char *pszFilename,
                                 long LinesPerPost) :
        m_filename(pszFilename),
        m_LinesPerPost(LinesPerPost)
{
    // determine file size, everyone needs this
    struct stat Stats;
    stat(m_filename.c_str(), &Stats);
    m_filesize = Stats.st_size;

    // find filename without path
    int pos = m_filename.find_last_of("\\/");
    if (-1 != pos)
        m_postname = m_filename.substr(pos+1);
    else
        m_postname = m_filename;
}
