// $Id: independent.h,v 1.2 2002/04/22 23:07:41 jjlupa Exp $
//
// ypost (Yet Another Poster)
// This code is copyright Jonathan Lupa, 2000. <jjlupa@jamdata.net>  To the
//  extent that it is released, it is released under the GNU General Public License
//  v2 or greater. The author retains all rights with respect to this code.
//
// If you have a desire to use this code outside of the GPL, drop me an email and
//  I would be happy to work with you under an alternate licence.  If you just want
//  to write code, then I would probably be happy to release it to you as under
//  the perl artistic license.
//
// independent.h - defines architecture dependent and independent code

#ifndef YPOST_INDEPENDENT_
#define YPOST_INDEPENDENT_

#include <vector>
#include <string>

//
// Functions with divergent implementation that share calls.
//
struct timeval;

namespace independent
{
    // sleep() : Using milliseconds was probably a terrible mistake. The rest of the damn program
    // uses usecs and secs.   Ah well.. DONT USE THIS FUNCTION FOR CRITICAL TIMING, use select().
    void sleep( unsigned int milli_seconds );

    // err which direction the slash goes in
    char slash();

    // errno or WSAGetLastError....
    int  sock_error();

    // gettimeofday is not implemented in win32... DON'T USE THE RESULT OF THIS AS AN ABSOLUTE... I
    // only plan for this to be used for high resolution delta's.  Windows has a max presision of about
    // 10ms, and I don't know what linux has, but regardless I want to be able to wrap this if I absolutely
    // need to.
    void get_time( timeval & tv );
}

//
// Functions only necessary to win32. functions exist as nop's in unix build if we need
// a similar thing here for linux, this is the place to put it.
//
namespace win32
{
    // windows doesn't expand matches from the shell like linux does. We do that manually
    // here...
    void expand_fns( std::string strmask, std::vector<std::string> & filenames );

    // Construct this object in main to get winsock fired up
    class wsa
    {
    public:
        wsa();
        ~wsa();
    };
}

#endif
