// $Id: nntp.h,v 1.4 2002/04/22 23:07:41 jjlupa Exp $
//
// ypost (Yet Another Poster)
// This code is copyright John Ridley, 2000. <john.ridley@gt.org>  To the
//  extent that it is released, it is released under the GNU General Public License
//  v2 or greater. The author retains all rights with respect to this code.
//
// If you have a desire to use this code outside of the GPL, drop me an email and
//  I would be happy to work with you under an alternate licence.  If you just want
//  to write code, then I would probably be happy to release it to you as under
//  the perl artistic license.

// nntp.h

#ifndef YPOST_NNTP_H_
#define YPOST_NNTP_H_

#include "socket.h"
#include <string>

class nntp
{
public:
    nntp( const char * server, int port);
    ~nntp();
    void setAuthInfo(const char *userid, const char *passwd);
    bool postArticle(const char *group, const char *from, const char *subject, const char *xheaders, const char *body);
    std::string lastResult()
    {
        return m_lastResult;
    }
    long bytesPosted()
    {
        return m_bytesPosted;
    }

protected:
    bool getResultCode();
    bool connect();
    bool disconnect();

    sock::socket * m_pSock;

    bool m_bConnected;
    std::string m_serverName, m_userid, m_passwd;
    int m_port;
    std::string m_lastResult;
    long m_bytesPosted;
};


#endif // _YPOST_NNTP_H_1
