// $Id: textencoder.cpp,v 1.4 2002/04/22 23:07:41 jjlupa Exp $
//
// ypost (Yet Another Poster)
// This code is copyright John Ridley, 2000. <john.ridley@gt.org>  To the
//  extent that it is released, it is released under the GNU General Public License
//  v2 or greater. The author retains all rights with respect to this code.
//
// If you have a desire to use this code outside of the GPL, drop me an email and
//  I would be happy to work with you under an alternate licence.  If you just want
//  to write code, then I would probably be happy to release it to you as under
//  the perl artistic license.

// textencoder.cpp
// not an actual encoder; it just takes the text file and puts it out
// as the one and only segment

namespace std
    {}
using namespace std;

#ifdef WIN32 // God can this get annoying...
#   pragma warning(disable:4786)
#endif

#include "ypost.h"
#include "textencoder.h"

#ifdef WIN32
#else
#   include <stdio.h>
#   include <unistd.h>
#endif

textencoder::textencoder(const char *pszFilename,
                         long LinesPerPost) :
        generic_encoder(pszFilename, LinesPerPost)
{
    m_numSegments = 1;
}


bool textencoder::EncodeSegment(long segment, char *buf, long size)
{
    // sanity checks
    if (   (size < BufSpaceNeeded())
            || (segment < 1)
            || (segment > m_numSegments))
        return false;

    // open the file
    FILE *infile;
    infile = fopen(m_filename.c_str(),"rb");
    if (NULL == infile)
        return false;
    long BytesToRead = m_filesize;
    char *curBufPos = buf;
    while (0 < BytesToRead)
    {
        long BytesRead = fread(curBufPos, 1, BytesToRead, infile);
        if (0 >= BytesRead)
        {
            fclose(infile);
            throw Ypost_Exception(Ypost_Exception::_FATAL_,
                                  "Error while reading text file");
        }
        curBufPos += BytesRead;
        BytesToRead -= BytesRead;
    }
    fclose(infile);
    return true;
}
